<?php

namespace xt_soapapi\xt_soapapi-php\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Client StructType
 * @subpackage Structs
 */
class Client extends AbstractStructBase
{
    /**
     * The Id
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $Id;
    /**
     * The Nom
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Nom;
    /**
     * The Prenom
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Prenom;
    /**
     * The Adresse
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Adresse;
    /**
     * The CodePostal
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CodePostal;
    /**
     * The Ville
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Ville;
    /**
     * The Pays
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Pays;
    /**
     * The NoTelephone
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $NoTelephone;
    /**
     * The Email
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Email;
    /**
     * The NoCarteFidelite
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $NoCarteFidelite;
    /**
     * Constructor method for Client
     * @uses Client::setId()
     * @uses Client::setNom()
     * @uses Client::setPrenom()
     * @uses Client::setAdresse()
     * @uses Client::setCodePostal()
     * @uses Client::setVille()
     * @uses Client::setPays()
     * @uses Client::setNoTelephone()
     * @uses Client::setEmail()
     * @uses Client::setNoCarteFidelite()
     * @param int $id
     * @param string $nom
     * @param string $prenom
     * @param string $adresse
     * @param string $codePostal
     * @param string $ville
     * @param string $pays
     * @param string $noTelephone
     * @param string $email
     * @param string $noCarteFidelite
     */
    public function __construct($id = null, $nom = null, $prenom = null, $adresse = null, $codePostal = null, $ville = null, $pays = null, $noTelephone = null, $email = null, $noCarteFidelite = null)
    {
        $this
            ->setId($id)
            ->setNom($nom)
            ->setPrenom($prenom)
            ->setAdresse($adresse)
            ->setCodePostal($codePostal)
            ->setVille($ville)
            ->setPays($pays)
            ->setNoTelephone($noTelephone)
            ->setEmail($email)
            ->setNoCarteFidelite($noCarteFidelite);
    }
    /**
     * Get Id value
     * @return int
     */
    public function getId()
    {
        return $this->Id;
    }
    /**
     * Set Id value
     * @param int $id
     * @return \xt_soapapi\xt_soapapi-php\StructType\Client
     */
    public function setId($id = null)
    {
        // validation for constraint: int
        if (!is_null($id) && !(is_int($id) || ctype_digit($id))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($id, true), gettype($id)), __LINE__);
        }
        $this->Id = $id;
        return $this;
    }
    /**
     * Get Nom value
     * @return string|null
     */
    public function getNom()
    {
        return $this->Nom;
    }
    /**
     * Set Nom value
     * @param string $nom
     * @return \xt_soapapi\xt_soapapi-php\StructType\Client
     */
    public function setNom($nom = null)
    {
        // validation for constraint: string
        if (!is_null($nom) && !is_string($nom)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($nom, true), gettype($nom)), __LINE__);
        }
        $this->Nom = $nom;
        return $this;
    }
    /**
     * Get Prenom value
     * @return string|null
     */
    public function getPrenom()
    {
        return $this->Prenom;
    }
    /**
     * Set Prenom value
     * @param string $prenom
     * @return \xt_soapapi\xt_soapapi-php\StructType\Client
     */
    public function setPrenom($prenom = null)
    {
        // validation for constraint: string
        if (!is_null($prenom) && !is_string($prenom)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($prenom, true), gettype($prenom)), __LINE__);
        }
        $this->Prenom = $prenom;
        return $this;
    }
    /**
     * Get Adresse value
     * @return string|null
     */
    public function getAdresse()
    {
        return $this->Adresse;
    }
    /**
     * Set Adresse value
     * @param string $adresse
     * @return \xt_soapapi\xt_soapapi-php\StructType\Client
     */
    public function setAdresse($adresse = null)
    {
        // validation for constraint: string
        if (!is_null($adresse) && !is_string($adresse)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($adresse, true), gettype($adresse)), __LINE__);
        }
        $this->Adresse = $adresse;
        return $this;
    }
    /**
     * Get CodePostal value
     * @return string|null
     */
    public function getCodePostal()
    {
        return $this->CodePostal;
    }
    /**
     * Set CodePostal value
     * @param string $codePostal
     * @return \xt_soapapi\xt_soapapi-php\StructType\Client
     */
    public function setCodePostal($codePostal = null)
    {
        // validation for constraint: string
        if (!is_null($codePostal) && !is_string($codePostal)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($codePostal, true), gettype($codePostal)), __LINE__);
        }
        $this->CodePostal = $codePostal;
        return $this;
    }
    /**
     * Get Ville value
     * @return string|null
     */
    public function getVille()
    {
        return $this->Ville;
    }
    /**
     * Set Ville value
     * @param string $ville
     * @return \xt_soapapi\xt_soapapi-php\StructType\Client
     */
    public function setVille($ville = null)
    {
        // validation for constraint: string
        if (!is_null($ville) && !is_string($ville)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ville, true), gettype($ville)), __LINE__);
        }
        $this->Ville = $ville;
        return $this;
    }
    /**
     * Get Pays value
     * @return string|null
     */
    public function getPays()
    {
        return $this->Pays;
    }
    /**
     * Set Pays value
     * @param string $pays
     * @return \xt_soapapi\xt_soapapi-php\StructType\Client
     */
    public function setPays($pays = null)
    {
        // validation for constraint: string
        if (!is_null($pays) && !is_string($pays)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($pays, true), gettype($pays)), __LINE__);
        }
        $this->Pays = $pays;
        return $this;
    }
    /**
     * Get NoTelephone value
     * @return string|null
     */
    public function getNoTelephone()
    {
        return $this->NoTelephone;
    }
    /**
     * Set NoTelephone value
     * @param string $noTelephone
     * @return \xt_soapapi\xt_soapapi-php\StructType\Client
     */
    public function setNoTelephone($noTelephone = null)
    {
        // validation for constraint: string
        if (!is_null($noTelephone) && !is_string($noTelephone)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($noTelephone, true), gettype($noTelephone)), __LINE__);
        }
        $this->NoTelephone = $noTelephone;
        return $this;
    }
    /**
     * Get Email value
     * @return string|null
     */
    public function getEmail()
    {
        return $this->Email;
    }
    /**
     * Set Email value
     * @param string $email
     * @return \xt_soapapi\xt_soapapi-php\StructType\Client
     */
    public function setEmail($email = null)
    {
        // validation for constraint: string
        if (!is_null($email) && !is_string($email)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($email, true), gettype($email)), __LINE__);
        }
        $this->Email = $email;
        return $this;
    }
    /**
     * Get NoCarteFidelite value
     * @return string|null
     */
    public function getNoCarteFidelite()
    {
        return $this->NoCarteFidelite;
    }
    /**
     * Set NoCarteFidelite value
     * @param string $noCarteFidelite
     * @return \xt_soapapi\xt_soapapi-php\StructType\Client
     */
    public function setNoCarteFidelite($noCarteFidelite = null)
    {
        // validation for constraint: string
        if (!is_null($noCarteFidelite) && !is_string($noCarteFidelite)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($noCarteFidelite, true), gettype($noCarteFidelite)), __LINE__);
        }
        $this->NoCarteFidelite = $noCarteFidelite;
        return $this;
    }
}
